> module STFun where

> newtype STFun s x = STFun (s -> (s,x))

> instance Functor (STFun s) where
>    fmap f (STFun sf) = STFun (\ s -> let (s',x) = sf s in (s', f x))

> instance Monad (STFun s) where
>    return x = STFun (\ s -> (s,x))
>    (STFun f) >>= g = STFun (\ s -> let (s', x) = f s; STFun g' = g x in g' s')
> accessST :: STFun s s
> accessST = STFun (\ s -> (s,s))

> runSTFun :: STFun s r -> s -> r
> runSTFun (STFun f) s = snd (f s)

> applySTFun :: STFun s r -> s -> (s,r)
> applySTFun (STFun f) s = f s
> clift :: (s -> s) -> STFun s ()
> clift f = STFun (\ s -> (f s, ()))

> clift1 :: (s -> a -> s) -> a -> STFun s ()
> clift1 f a = STFun (\ s -> (f s a, ()))

> clift2 :: (s -> a -> b -> s) -> a -> b -> STFun s ()
> clift2 f a b = STFun (\ s -> (f s a b, ()))

> clift3 :: (s -> a -> b -> c -> s) -> a -> b -> c -> STFun s ()
> clift3 f a b c = STFun (\ s -> (f s a b c, ()))

> rlift :: (s -> r) -> STFun s r
> rlift f = STFun (\ s -> (s, f s))

> rlift1 :: (s -> a -> r) -> a -> STFun s r
> rlift1 f a = STFun (\ s -> (s, f s a))

> rlift2 :: (s -> a -> b -> r) -> a -> b -> STFun s r
> rlift2 f a b = STFun (\ s -> (s, f s a b))

